/*
 *
 *	Licensed Materials - Property of IBM
 *
 *	IBM Rational Mobile Test
 *
 *	(C) Copyright IBM Corporation 2014. All Rights Reserved. 
 *
 *	Note to U.S. Government Users Restricted Rights:  
 *	Use, duplication or disclosure restricted by GSA ADP
 *	Schedule Contract with IBM Corp. 
 *
 */

function callJSCustomcodeFunc(jscustfun, args) {
	var ret = { jsstatus: true, retVal: "" };
	jscustfun = (typeof jscustfun == "function") ? jscustfun : window[jscustfun];  // Allow jscustfun to be a function object or the name of a global function
	try {
		retVal = jscustfun.apply(this, args || []);  // args is optional, use an empty array by default
		if((typeof retVal != 'undefined') && (retVal != null)) {
			retVal = retVal.toString();
		}
		ret.retVal = retVal;
	}catch(err) {
		ret.jsstatus = false;
		ret.retVal = err.message;
	}
	
	return ret;
}
