DialogHandler = function() {

	this.emtpyHierarchy = [ {
		"children" : [ {} ]
	} ];
};

var WebGUIdebug = false;

DialogHandler.prototype = {

	handleDialog : function(eventName, parameters, actionId, rect) {

		try {
			var mainDoc = jsUtil.getMainDocument();
			var jsonString = rmotRecorder.buildJsonStringDesktop(false, eventName, eventName, null, this.emtpyHierarchy, parameters, actionId, rect.left,
					rect.top, rect, true);
			rmotRecorder.logEvent(jsonString);
			if(WebGUIdebug)
				rmotRecorder.log("json dlg 2 : " + eventName + " -- " + actionId + " -- " + rect + " -- " + JSON.stringify({ parameters : parameters }));
		}
		catch (err) {
			rmotRecorder.log(err);
		}
	},

	requestSnapshot : function() {

		var ssid = (new Date()).getTime();
		var rect = this.getSnapShotRect();
		rmotRecorder.postXMLHttpRequest('/RTWWebGui/Snapshot', JSON.stringify({
			actionId : ssid,
			snapshotRect : rect,
			tagName : 'BROWSER',
			snapshot : false,
			isDialog : true
		}), true);
		return {
			ssid : ssid,
			rect : rect
		};
	},

	getSnapShotRect : function() {

		var mainWindow = jsUtil.getMainDocument().defaultView;
		return "left:" + BROWSER_ZOOM_FACT * this.getWindowLeft(mainWindow) + ";top:" + BROWSER_ZOOM_FACT * this.getWindowTop(mainWindow) + ";right:"
				+ BROWSER_ZOOM_FACT * this.getWindowRight(mainWindow) + ";bottom:" + BROWSER_ZOOM_FACT * this.getWindowBottom(mainWindow) + ";";
	},

	getWindowLeft : function(mainWindow) {

		return mainWindow.mozInnerScreenX || mainWindow.screenLeft || mainWindow.screenX || 0;
	},

	getWindowTop : function(mainWindow) {

		return mainWindow.mozInnerScreenY || mainWindow.screenTop || mainWindow.screenY || 0;
	},

	getWindowRight : function(mainWindow) {

		return this.getWindowLeft(mainWindow) + this.getWindowWidth(mainWindow);
	},

	getWindowBottom : function(mainWindow) {

		return this.getWindowTop(mainWindow) + this.getWindowHeight(mainWindow);
	},

	getWindowWidth : function(mainWindow) {

		return mainWindow.mozInnerScreenX ? mainWindow.innerWidth : mainWindow.outerWidth;
	},

	getWindowHeight : function(mainWindow) {

		return mainWindow.mozInnerScreenY ? mainWindow.innerHeight : mainWindow.outerHeight;
	},

	addDialogEventListener : function(winObject) {

		try {
			if (winObject.alert.toString().indexOf("originalAlert") < 0) {
				winObject.originalAlert = winObject.alert;
				winObject.alert = function(message) {

					if(WebGUIdebug)
						rmotRecorder.log("alert : " + message);
					if (rmotRect != undefined && rmotRect.RMoTRect) {
						rmotRect.removeRectangle();
					}
					var ssinfo = dialogHandler.requestSnapshot();
					var val = this.originalAlert(message);
					if(WebGUIdebug)  rmotRecorder.log("alert done : " + val);
					var parameters = {};
					parameters.message = message;
					parameters.alerttext = message;
					parameters.verifytext = false;
					parameters.jsbutton = true;
					if(WebGUIdebug)  rmotRecorder.log("alert handle ");
					dialogHandler.handleDialog("alert", parameters, ssinfo.ssid, ssinfo.rect);
					if(WebGUIdebug)  rmotRecorder.log("alert handle done");
					return val;
				}
			}
		}
		catch (error) {
			rmotRecorder.log("Error overriding alert : " + error);
		}

		try {
			if (winObject.confirm.toString().indexOf("originalConfirm") < 0) {
				winObject.originalConfirm = winObject.confirm;
				winObject.confirm = function(message) {

					if(WebGUIdebug)  rmotRecorder.log("confirm : " + message);
					if (rmotRect != undefined && rmotRect.RMoTRect) {
						rmotRect.removeRectangle();
					}
					var ssinfo = dialogHandler.requestSnapshot();
					var ok = this.originalConfirm(message);
					if(WebGUIdebug)  rmotRecorder.log("confirm done : " + ok);
					var parameters = {};
					parameters.jsbutton = ok;
					parameters.message = message;
					parameters.alerttext = message;
					parameters.verifytext = false;
					if(WebGUIdebug)  rmotRecorder.log("confirm : handle");
					dialogHandler.handleDialog("confirm", parameters, ssinfo.ssid, ssinfo.rect);
					if(WebGUIdebug)  rmotRecorder.log("confirm : handle done.");
					return ok;
				}
			}
		}
		catch (error) {
			rmotRecorder.log("Error overriding confirm : " + error);
		}

		try {
			if (winObject.prompt.toString().indexOf("originalPrompt") < 0) {
				winObject.originalPrompt = winObject.prompt;
				winObject.prompt = function(message, input) {

					if(WebGUIdebug)  rmotRecorder.log("prompt : " + message);
					if (rmotRect != undefined && rmotRect.RMoTRect) {
						rmotRect.removeRectangle();
					}
					var ssinfo = dialogHandler.requestSnapshot();
					var newinput = this.originalPrompt(message, input);
					if(WebGUIdebug)  rmotRecorder.log("prompt : done." + newinput);
					var parameters = {};
					if (newinput == null) {
						parameters.jsbutton = false;
						if (input == null || input == undefined) {
							input = "";
						}
						parameters.newtext = input;
					}
					else {
						parameters.jsbutton = true;
						parameters.newtext = newinput;
					}
					parameters.text = input;
					parameters.message = message;
					parameters.alerttext = message;
					parameters.verifytext = false;
					if(WebGUIdebug)  rmotRecorder.log("prompt : handle");
					dialogHandler.handleDialog("prompt", parameters, ssinfo.ssid, ssinfo.rect);
					if(WebGUIdebug)  rmotRecorder.log("prompt : handle done : " + newinput);
					return newinput;
				}
			}
		}
		catch (error) {
			rmotRecorder.log("Error overriding prompt : " + error);
		}

	},
};